<?php

namespace Drupal\username_phone\Entity;

use Drupal\Core\Entity\EntityTypeInterface;
use Drupal\Core\Field\BaseFieldDefinition;
use Drupal\user\Entity\User as BaseUser;

/**
 * A custom username phone class for the User entity.
 */
class UsernamePhoneUser extends BaseUser {

  /**
   * {@inheritdoc}
   */
  public function getPhone() {
    return $this->get('phone')->value;
  }

  /**
   * {@inheritdoc}
   */
  public function setPhone($phone) {
    $this->get('phone')->value = $phone;
    return $this;
  }

  /**
   * {@inheritdoc}
   */
  public static function baseFieldDefinitions(EntityTypeInterface $entity_type) {
    /** @var \Drupal\Core\Field\BaseFieldDefinition[] $fields */
    $fields = parent::baseFieldDefinitions($entity_type);

    $fields['phone'] = BaseFieldDefinition::create('string')
      ->setLabel(t('Phone number'))
      ->setDescription(t('The phone number of this user.'))
      ->setDefaultValue('')
      ->addConstraint('UsernamePhoneUnique')
      ->addConstraint('UsernamePhoneRequired')
      ->addConstraint('ProtectedUserField');

    return $fields;
  }

}
